﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace HeuristicLab.Services.Hive.DataAccess {
  using DT = HeuristicLab.Services.Hive.Common.DataTransfer;

  public interface IHiveDao {
    #region Job Methods
    DT.Job GetJob(Guid id);
    IEnumerable<DT.Job> GetJobs(Expression<Func<Job, bool>> predicate);
    Guid AddJob(DT.Job dto);
    void UpdateJob(DT.Job dto);
    void DeleteJob(Guid id);
    IEnumerable<DT.Job> GetAvailableJobs(DT.Slave slave);
    #endregion

    #region JobData Methods
    DT.JobData GetJobData(Guid id);
    IEnumerable<DT.JobData> GetJobDatas(Expression<Func<JobData, bool>> predicate);
    Guid AddJobData(DT.JobData dto);
    void UpdateJobData(DT.JobData dto);
    void DeleteJobData(Guid id);
    #endregion

    #region HiveExperiment Methods
    DT.HiveExperiment GetHiveExperiment(Guid id);
    IEnumerable<DT.HiveExperiment> GetHiveExperiments(Expression<Func<HiveExperiment, bool>> predicate);
    Guid AddHiveExperiment(DT.HiveExperiment dto);
    void UpdateHiveExperiment(DT.HiveExperiment dto);
    void DeleteHiveExperiment(Guid id);
    #endregion

    #region Plugin Methods
    #endregion

    #region PluginData Methods
    #endregion

    #region Calendar Methods
    #endregion

    #region Slave Methods
    DT.Slave GetSlave(Guid id);
    IEnumerable<DT.Slave> GetSlaves(Expression<Func<Slave, bool>> predicate);
    Guid AddSlave(DT.Slave dto);
    void UpdateSlave(DT.Slave dto);
    void DeleteSlave(Guid id);
    #endregion

    #region SlaveGroup Methods
    DT.SlaveGroup GetSlaveGroup(Guid id);
    IEnumerable<DT.SlaveGroup> GetSlaveGroups(Expression<Func<SlaveGroup, bool>> predicate);
    Guid AddSlaveGroup(DT.SlaveGroup dto);
    void UpdateSlaveGroup(DT.SlaveGroup dto);
    void DeleteSlaveGroup(Guid id);
    #endregion

    #region Resource Methods
    DT.Resource GetResource(Guid id);
    IEnumerable<DT.Resource> GetResources(Expression<Func<Resource, bool>> predicate);
    Guid AddResource(DT.Resource dto);
    void UpdateResource(DT.Resource dto);
    void DeleteResource(Guid id);
    #endregion

    #region Authorization Methods
    bool IsUserAuthorizedForJobs(Guid userId, params Guid[] jobIds);
    #endregion
  }
}
